<?php
/**
 * @author		J-F Bohemier, angelicode.com
 * @copyright	(C) 2012 Jean-François Bohémier
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 *
 * This hikashop plugin creates a unique ID for each downloads when an order contains downloadable goods
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgHikashopDownloadLink extends JPlugin
{
	function plgHikashopDownloadLink(&$subject, $config){
		parent::__construct($subject, $config);
		
		// Install database if doesn't exists
		// Todo: Find a more elegant way to do this? Once at install perhaps...
		$database =& JFactory::getDBO();
		$dbtable  = hikashop_table('downloadids');
		$table_query = "CREATE TABLE IF NOT EXISTS $dbtable (".
		  "`download_id` varchar(255) NOT NULL,".
		  "`file_id` int(10) unsigned NOT NULL,".
		  "`order_id` int(10) unsigned NOT NULL,".
		  "PRIMARY KEY  (`download_id`),".
		  "UNIQUE KEY `file_id` (`file_id`,`order_id`)".
		") ENGINE=MyISAM DEFAULT CHARSET=utf8;";
		$database->setQuery( $table_query );
		if (!$database->query()) {
		  //return the error
		  $status['error'] = 'Error : ' . $$database->stderr();
		  return $status;
		}
	}

	function onAfterOrderCreate(&$order, &$send_email) {
    	if(!empty($order->order_id)){
			$database =& JFactory::getDBO();
			$dbtable = hikashop_table('downloadids');
			$class = hikashop_get('class.order');
			$data = $class->get($order->order_id);
			$data->cart = $class->loadFullOrder($data->order_id,true,false);
			foreach($data->cart->products as $item){
				if(!empty($item->files)){
					foreach($item->files as $file){
						$fileid = $file->file_id;
						$orderid = $order->order_id;
						$fileName = empty($file->file_name) ? $file->file_path : $file->file_name;
						$downloadid = uniqid(); 
						$query = "INSERT INTO $dbtable (`download_id`, `file_id`, `order_id`) VALUES ('$downloadid', '$fileid', '$orderid');";
						$database->setQuery($query);
						$database->query();
					}
				}
			}
		}
	}

	function onAfterOrderDelete($elements) {
		$database =& JFactory::getDBO();
		$dbtable = hikashop_table('downloadids');
    	foreach ($elements as $order_id) {
			$query = "DELETE FROM $dbtable WHERE `order_id`=$order_id";
			$database->setQuery($query);
			$database->query();
		}
	}
}



